;***************************************************************************************************
;    This is a console application to determine if operating system is Vista.            
;        
;        Current Date: December 27, 2010            
;***************************************************************************************************
.486    ; minimum processor needed for 32 bit     
.model flat, stdcall       ;  selects the programming model      
option casemap:none        ;  case sensitive    
;***************************************************************************************************
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc    
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
;***************************************************************************************************

OSVERSIONINFOEXsdk STRUCT
  dwOSVersionInfoSize DWORD ?
  dwMajorVersion  DWORD ?
  dwMinorVersion  DWORD ?
  dwBuildNumber   DWORD ?
  dwPlatformId    DWORD ?
  szCSDVersion    BYTE  128  dup (?)
  wServicePackMajor WORD ?
  wServicePackMinor WORD ?
  wSuiteMask WORD ?    
  wProductType BYTE ?
  wReserved BYTE ?
OSVERSIONINFOEXsdk ENDS

;***************************************************************************************************

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
TestForVista PROTO    
DwtoA PROTO :DWORD,:DWORD

;***************************************************************************************************
.data    
;***************************************************************************************************
    hInstance   HINSTANCE 0    
    CommandLine LPSTR 0    
    hMainWnd HWND 0    
    ClassName db "TestVista", 0    
    AppName  db "Simple Test Application for Vista OS", 0    
    CurDirctry BYTE 256 DUP(0)    ;  Path for Current Directory    
    PathDatDir BYTE  256 DUP(0)    ;  Path to use in CreateDirectory    
    InfoFile BYTE 256 DUP(0)    ;  Path to the Information File    
    szNamDirectry BYTE "\\Result", 0    
    szNameInfo BYTE "\\Vista Info.txt", 0    
    hInfFile HANDLE 0    ;  Handle returned from CreateFile    
    LoadLibName BYTE 128 DUP(0)    ;  Memory buffer for name and path of DLL.    
    ProcAddrName BYTE 64 DUP(0)    ;  Memory buffer for name of function used in GetProcAddress.    
    CurWindwsDir BYTE 128 DUP(0)    ;  Memory buffer for path of Windows directory.    
    szKernel32Lib BYTE "\\kernel32.dll", 0    
    hKrnl32Lib HMODULE 0    ;  HMODULE returned from LoadLibrary (kernel32.dll).   
    szRowDelmt BYTE "--------------------------------------------------------------------------------", 0Dh, 0Ah, 0
    szResultTest  BYTE "The result of the test is: ", 0Dh, 0Ah, 0
    OpertngSystm OSVERSIONINFOEXsdk <>  
    szErrGetVersn BYTE "GetVersionEx FAILED. Operating System is older than Windows 98.", 0Dh, 0Ah, 0      
    szOlderOprSys BYTE "The installed operating system is older than Windows Vista.", 0Dh, 0Ah, 0    
    szGetProdctInfo BYTE "GetProductInfo", 0    ;     
    dwGetProductInfo DWORD 0    ;    This is the address of GetProductInfo returned from GetProcAddress.    
    szErrGetProdctInf BYTE "ERROR: GetProcAddress FAILED for GetProductInfo.", 0Dh, 0Ah, 0
    szErRtnGtPrdtInfo BYTE "ERROR: GetProductInfo FAILED. Return value zero.", 0Dh, 0Ah, 0
    dwRtnPrdctTyp DWORD 0    ;    Returned from GetProductInfo.    
    DsplVistaVerEdtn BYTE 128 DUP (0)    ;    Buffer to hold string that describes Vista edition.    
    szWinVistaWrkStn BYTE "The Installed Operating System is: Windows Vista, ", 0    ;    Released 2006, User Account Control added. 
    szWinSrvr2008Stnd BYTE "The Installed Operating System is: Windows Server 2008, ", 0   
    szUltimatEdtn BYTE "Ultimate Edition.", 0    
    szVstaProfesnl BYTE "Professional.", 0     
    szHomePremium BYTE "Home Premium Edition.", 0    
    szHoneBasic BYTE "Home Basic Edition.", 0    
    szEntrpriseEdtn BYTE " Enterprise Edition.", 0    
    szEntrprseSrvrEdtn BYTE "Enterprise Server Edition (Full Installation).", 0    
    szBusinesEdtn BYTE "Business Edition.", 0    
    szStartrEditn BYTE  "Starter Edition.", 0    
    szClustrSrvrEdtn BYTE "Cluster Server Edition.", 0    
    szDataCntrEdtn BYTE "Datacenter Server Edition (Full Installation),", 0    
    szDatCntrCoreEdtn BYTE "Datacenter Edition (Core Installation).", 0     
    szEntrprsCoreEdtn BYTE "Enterprise Edition (Core Installation).", 0     
    szEntrprsItaniumEdtn BYTE "Enterprise Server Edition for Itanium-based Systems.", 0    
    szSmalBusinsSrvr BYTE "Small Business Server.", 0    
    szSmalBusnsSrvrPrem BYTE "Small Business Server Premium Edition.", 0    
    szStandrdEdtn BYTE "Standard Server Edition (Full Installation).", 0    
    szStandrdCoreEdtn BYTE "Standard Edition (Core Installation).", 0     
    szWebSrvrEdtn BYTE "Web Server Edition (Full Installation).", 0    
    szEndLine BYTE 0Dh, 0Ah, 0   
    DsplBuldNumbr BYTE 128 DUP(0)    ;  Buffer to hold Build Number String.    
    OSBuildNum BYTE 32 DUP (0)    ;  Buffer to hold value converted with DwtoA 
    szWinBldNum BYTE "The Build Number of the Operating System is: ", 0    
    szNoServicePack BYTE "There are NO currently installed Service Packs.", 0Dh, 0Ah, 0
    DsplServcPacks BYTE 128 DUP(0)    ;  Buffer to hold Service Packs installed.    
    ServicePack BYTE 32 DUP (0)    ;  Buffer to hold values converted with DwtoA 
    szInstlSrvcPck BYTE "The Latest Service Pack installed is: ", 0    
    szMajSrvcPk BYTE "Major: ", 0    
    szMinrSrvPk BYTE ", Minor: ", 0    
    szWinSevnWrkStn BYTE "The Installed Operating System is: Windows Seven.", 0Dh, 0Ah, 0    ;    Released 2009.    

;    Define the Product Types for the return value from GetProductInfo (Vista and greater).    51 total    
;    Many of these values are already defined in windows.inc    I have commented them out.    

;    PRODUCT_UNDEFINED equ 00000000h
;    PRODUCT_UNLICENSED equ ABCDABCDh
;    PRODUCT_BUSINESS equ 00000006h
;    PRODUCT_BUSINESS_N equ 00000010h
;    PRODUCT_CLUSTER_SERVER equ 00000012h
;    PRODUCT_DATACENTER_SERVER equ 00000008h
;    PRODUCT_DATACENTER_SERVER_CORE equ 0000000Ch
PRODUCT_DATACENTER_SERVER_CORE_V equ 00000027h
PRODUCT_DATACENTER_SERVER_V equ 00000025h
;    PRODUCT_ENTERPRISE equ 00000004h
PRODUCT_ENTERPRISE_E equ 00000046h    ;    Not Supported
PRODUCT_ENTERPRISE_N equ 0000001Bh
;    PRODUCT_ENTERPRISE_SERVER equ 0000000Ah
;    PRODUCT_ENTERPRISE_SERVER_CORE equ 0000000Eh
PRODUCT_ENTERPRISE_SERVER_CORE_V equ 00000029h
;    PRODUCT_ENTERPRISE_SERVER_IA64 equ 0000000Fh
PRODUCT_ENTERPRISE_SERVER_V equ 00000026h
;    PRODUCT_HOME_BASIC equ 00000002h
PRODUCT_HOME_BASIC_E equ 00000043h    ;    Not Supported
;    PRODUCT_HOME_BASIC_N equ 00000005h
;    PRODUCT_HOME_PREMIUM equ 00000003h
PRODUCT_HOME_PREMIUM_E equ 00000044h    ;    Not Supported
PRODUCT_HOME_PREMIUM_N equ 0000001Ah
PRODUCT_HYPERV equ 0000002Ah
PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT equ 0000001Eh
PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING equ 00000020h
PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY equ 0000001Fh
PRODUCT_PROFESSIONAL equ 00000030h
PRODUCT_PROFESSIONAL_E equ 00000045h    ;    Not Supported
PRODUCT_PROFESSIONAL_N equ 00000031h 
;    PRODUCT_SERVER_FOR_SMALLBUSINESS equ 00000018h
PRODUCT_SERVER_FOR_SMALLBUSINESS_V equ 00000023h
PRODUCT_SERVER_FOUNDATION equ 00000021h
;    PRODUCT_SMALLBUSINESS_SERVER equ 00000009h
;    PRODUCT_SMALLBUSINESS_SERVER_PREMIUM equ 00000019h
PRODUCT_SOLUTION_EMBEDDEDSERVER equ 00000038h 
;    PRODUCT_STANDARD_SERVER equ 00000007h
;    PRODUCT_STANDARD_SERVER_CORE equ 0000000Dh
PRODUCT_STANDARD_SERVER_CORE_V equ 00000028h
PRODUCT_STANDARD_SERVER_V equ 00000024h
;    PRODUCT_STARTER equ 0000000Bh
PRODUCT_STARTER_E equ 00000042h    ;    Not Supported
PRODUCT_STARTER_N equ 0000002Fh
;    PRODUCT_STORAGE_ENTERPRISE_SERVER equ 00000017h
;    PRODUCT_STORAGE_EXPRESS_SERVER equ 00000014h
;    PRODUCT_STORAGE_STANDARD_SERVER equ 00000015h
;    PRODUCT_STORAGE_WORKGROUP_SERVER equ 00000016h
;    PRODUCT_ULTIMATE equ 00000001h
PRODUCT_ULTIMATE_E equ 00000047h    ;    Not Supported
PRODUCT_ULTIMATE_N equ 0000001Ch
;    PRODUCT_WEB_SERVER equ 00000011h 
PRODUCT_WEB_SERVER_CORE equ 0000001Dh

;***************************************************************************************************
.code
;***************************************************************************************************

start:
    INVOKE GetModuleHandle, NULL
    MOV hInstance, eax
    INVOKE GetCommandLine
    MOV CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax

;***************************************************************************************************

WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
            LOCAL ExtStyle:DWORD
            LOCAL WndStyle:DWORD
            LOCAL dwSpace:DWORD
            LOCAL dwWidth:DWORD    
            LOCAL dwHeight:DWORD  

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
            INVOKE GetStockObject, 2    ;  GRAY_BRUSH    
	mov   wc.hbrBackground, eax
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName,OFFSET ClassName
	INVOKE LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	INVOKE LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	INVOKE RegisterClassEx, ADDR wc

;    Set the Extended Windows Style and the Windows Style here.    
            XOR eax, eax
;    WS_EX_TOPMOST | WS_EX_NOINHERITLAYOUT = 100008h  or 1048584      
            mov eax, 1048584
            mov ExtStyle, eax    
            XOR eax, eax
;    WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN = 0BC15F600h  or  315555840    
            mov eax, 315555840
            mov  WndStyle, eax    

;    Calculate the correct x and y screen coordinates for the extended windows style here.    
            XOR ebx, ebx
            INVOKE GetSystemMetrics, SM_CXBORDER    
            mov dwSpace, eax
            mov ebx, 2
            MUL ebx
            mov ebx, 1024
            SUB ebx, eax
            mov dwWidth, ebx
            XOR ebx, ebx
            INVOKE GetSystemMetrics, SM_CYBORDER
            mov ebx, 2
            MUL ebx
            mov ebx, 768
            SUB ebx, eax
            mov dwHeight, ebx

	INVOKE CreateWindowEx, ExtStyle, ADDR ClassName, ADDR AppName, WndStyle, dwSpace, 0, dwWidth, dwHeight, NULL, NULL, hInst, NULL
	mov  hMainWnd, eax
	INVOKE ShowWindow, hMainWnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hMainWnd

            INVOKE TestForVista

	.WHILE TRUE
		INVOKE GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		INVOKE TranslateMessage, ADDR msg
		INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax, msg.wParam
	RET
WinMain ENDP

;***************************************************************************************************

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_DESTROY
		INVOKE PostQuitMessage, NULL
                        MOV eax, 0
                        RET
	.ELSE
		INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam		
		RET
	.ENDIF

WndProc ENDP

;***************************************************************************************************

TestForVista PROC    
    LOCAL lpDataDir:LPTSTR     
    LOCAL lpInfoFl:LPTSTR   
    LOCAL lpWinSysDir:DWORD
    LOCAL lpPathKrnlDll:DWORD
    LOCAL lpPrdctInfoNam:DWORD    
    LOCAL dwAddrPrdctInfo:DWORD
    LOCAL dwLenWrt:DWORD    
    LOCAL dwLenNum:DWORD  
    LOCAL dwCurFilePtr:DWORD   
    LOCAL lpVistaEdtn:DWORD

;  If the GetCurrentDirectory function fails, the return value is zero.     
    MOV eax, 0
    MOV lpDataDir, eax 
    MOV  lpInfoFl, eax 
    INVOKE GetCurrentDirectory, 256, ADDR CurDirctry    
    .IF eax==0
     RET
    .ENDIF    
;  If lstrcpy fails, the return value is NULL    
    INVOKE lstrcpy, ADDR PathDatDir, ADDR CurDirctry        
    .IF eax==0
     RET
    .ENDIF    
   INVOKE lstrcat, ADDR PathDatDir, ADDR szNamDirectry        
    .IF eax==0
     RET
    .ENDIF    
    MOV eax, OFFSET PathDatDir    
    MOV lpDataDir, eax    
    
;  If CreateDirectory fails, the return value is zero. If the directory already    
;  exists, CreateDirectory fails, but, calling GetLastError returns 183.        
    INVOKE CreateDirectory, lpDataDir, NULL
    .IF eax==0
     INVOKE GetLastError
     CMP eax, 183
     JZ DirExists    
     RET    
    .ENDIF  

DirExists:
    INVOKE lstrcpy, ADDR InfoFile, ADDR PathDatDir 
    INVOKE lstrcat, ADDR InfoFile, ADDR szNameInfo 
    MOV eax, OFFSET InfoFile    
    MOV   lpInfoFl, eax    
;  If CreateFile fails, the return value is INVALID_HANDLE_VALUE    
;  Combining GENERIC_READ and GENERIC_WRITE give a value of: C0000000h hex or 3221225472 decimal.    
    INVOKE CreateFile,  lpInfoFl, 0C0000000h, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL    
    .IF eax==INVALID_HANDLE_VALUE
     RET    
    .ENDIF    
    MOV hInfFile, eax    
    INVOKE SetFilePointer, hInfFile, 0, NULL, FILE_BEGIN
    MOV dwCurFilePtr, eax    
    INVOKE lstrlen, ADDR szRowDelmt
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szRowDelmt, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE lstrlen, ADDR szResultTest
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szResultTest, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE lstrlen, ADDR szRowDelmt
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szRowDelmt, dwLenWrt, ADDR dwLenNum, NULL

;  User Mode function GetVersionEx fills OSVERSIONINFOEX structure with data. This        
;  will fail on Windows Versions 95/98/Me. The OSVERSIONINFOEX structure is 
;  available on Windows NT 4.0 SP6 and later. Before calling the GetVersionEx function,    
;  Set the dwOSVersionInfoSize member to sizeof OSVERSIONINFOEXsdk.

    MOV eax, 156    ;  This is size of OSVERSIONINFOEX structure.    
    MOV OpertngSystm.dwOSVersionInfoSize, eax    
;  If GetVersionEx fails, the return value is zero. 
    INVOKE GetVersionEx, ADDR OpertngSystm
    .IF eax!=0
    JNZ DetermnVersn
    .ENDIF
    INVOKE lstrlen, ADDR szErrGetVersn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szErrGetVersn, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE CloseHandle, hInfFile
    RET   

BeforeVista:
    INVOKE lstrlen, ADDR szOlderOprSys
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szOlderOprSys, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr

DetermnVersn:
;    dwMajorVersion = 6 designates Windows Vista, Windows Server 2008, and Windows 7.    
    CMP OpertngSystm.dwMajorVersion, 6
    JB BeforeVista    ;    Comparison of unsigned integers (jump if, dwMajorVersion < 6)

    MOV eax, 0    
    MOV lpWinSysDir, eax
    MOV lpPathKrnlDll, eax
    MOV dwAddrPrdctInfo, eax
    INVOKE RtlZeroMemory, ADDR LoadLibName, 128
    INVOKE RtlZeroMemory, ADDR ProcAddrName, 64
    INVOKE RtlZeroMemory, ADDR CurWindwsDir, 128
    MOV eax, OFFSET LoadLibName
    MOV lpPathKrnlDll, eax
    MOV eax, OFFSET CurWindwsDir
    MOV lpWinSysDir, eax
    MOV eax, OFFSET ProcAddrName
    MOV lpPrdctInfoNam, eax
    INVOKE GetSystemDirectory, lpWinSysDir, 128
    INVOKE lstrcpy, lpPathKrnlDll, lpWinSysDir
    INVOKE lstrcat, lpPathKrnlDll, ADDR szKernel32Lib 
    INVOKE LoadLibrary, lpPathKrnlDll
    MOV hKrnl32Lib, eax    
    CMP hKrnl32Lib, 0
    JNZ PrcAdrPrdctInf
    INVOKE CloseHandle, hInfFile
    RET

PrcAdrPrdctInf:
    INVOKE lstrcpy, lpPrdctInfoNam, ADDR szGetProdctInfo
    INVOKE GetProcAddress, hKrnl32Lib, lpPrdctInfoNam     
    MOV dwAddrPrdctInfo, eax
    CMP eax, 0
    JNZ GtPrdctInfo
    INVOKE lstrlen, ADDR szErrGetProdctInf   
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szErrGetProdctInf, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE CloseHandle, hInfFile
    RET    

GtPrdctInfo:
;    There are five DWORD sized parameters that must be pushed on the stack in     
;    reverse order. The returned DWORD VALUE is a pointer to a DWORD.    

    MOV eax, OFFSET dwRtnPrdctTyp    ;    This parameter cannot be NULL
    push eax
    MOVZX eax, OpertngSystm.wServicePackMinor    ;    The minimum value is 0.
    push eax
    MOVZX eax, OpertngSystm.wServicePackMajor    ;     The minimum value is 0.
    push eax
    MOV eax, OpertngSystm.dwMinorVersion    ;    The minimum value is 0.
    push eax
    MOV eax, OpertngSystm.dwMajorVersion    ;    The minimum value is 6.
    push eax
    CALL dwAddrPrdctInfo
;    This function fails if one of the input parameters is invalid. Check for error.    
    CMP eax, 0    ;    If the function fails, the return value is zero.     
    JNZ SixChkMinVer
    INVOKE lstrlen, ADDR szErRtnGtPrdtInfo   
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szErRtnGtPrdtInfo, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE CloseHandle, hInfFile
    RET   

SixChkMinVer:
;  dwMajorVersion = 6  dwMinorVersion = 0  is Windows Vista     
    CMP OpertngSystm.dwMinorVersion, 0    
    JZ WinVista
;  dwMajorVersion = 6  dwMinorVersion = 1  is Windows Seven or Windows Server 2008 R2.     
    CMP OpertngSystm.dwMinorVersion, 1    
    JZ WinSeven

WinVista:
    CMP OpertngSystm.wProductType, VER_NT_WORKSTATION
    JNZ WinSrvr2008
    INVOKE RtlZeroMemory, ADDR DsplVistaVerEdtn, 128
    MOV eax, OFFSET DsplVistaVerEdtn
    MOV lpVistaEdtn, eax
    INVOKE lstrcpy, ADDR DsplVistaVerEdtn, ADDR szWinVistaWrkStn
    JMP AddVstaEditn

WinSrvr2008:
    INVOKE RtlZeroMemory, ADDR DsplVistaVerEdtn, 128
    MOV eax, OFFSET DsplVistaVerEdtn
    MOV lpVistaEdtn, eax
    INVOKE lstrcpy, ADDR DsplVistaVerEdtn, ADDR szWinSrvr2008Stnd

AddVstaEditn:
;    There are a number of flag values that are not handled here.    

    .IF dwRtnPrdctTyp==PRODUCT_ULTIMATE   
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szUltimatEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_PROFESSIONAL
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szVstaProfesnl
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_HOME_PREMIUM
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szHomePremium
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_HOME_BASIC
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szHoneBasic
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_ENTERPRISE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrpriseEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_BUSINESS
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szBusinesEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_STARTER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStartrEditn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_CLUSTER_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szClustrSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_DATACENTER_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szDataCntrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_DATACENTER_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szDatCntrCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_ENTERPRISE_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprseSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_ENTERPRISE_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprsCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_ENTERPRISE_SERVER_IA64
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprsItaniumEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_SMALLBUSINESS_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szSmalBusinsSrvr
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_SMALLBUSINESS_SERVER_PREMIUM
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szSmalBusnsSrvrPrem
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_STANDARD_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStandrdEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_STANDARD_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStandrdCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSEIF dwRtnPrdctTyp==PRODUCT_WEB_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szWebSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    
    .ELSE    
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplVistaVerEdtn, dwLenWrt, ADDR dwLenNum, NULL
    JMP BuildNumbr
    .ENDIF    

WinSeven:
;    The server version of Windows Seven (Major = 6, Minor = 1), is Windows Server 2008 R2.     
    invoke lstrlen, ADDR szWinSevnWrkStn
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szWinSevnWrkStn, dwLenWrt, ADDR dwLenNum, NULL

BuildNumbr:    
    INVOKE RtlZeroMemory, ADDR DsplBuldNumbr, 128
    INVOKE RtlZeroMemory, ADDR OSBuildNum, 32
    MOV eax, OpertngSystm.dwBuildNumber
    INVOKE DwtoA, eax, ADDR OSBuildNum
    INVOKE lstrcpy, ADDR DsplBuldNumbr, ADDR szWinBldNum    
    INVOKE lstrcat, ADDR DsplBuldNumbr, ADDR OSBuildNum    
    INVOKE lstrcat, ADDR DsplBuldNumbr, ADDR szEndLine    
    INVOKE lstrlen, ADDR DsplBuldNumbr
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplBuldNumbr, dwLenWrt, ADDR dwLenNum, NULL

    CMP OpertngSystm.wServicePackMajor, 0
    JZ NoServcPack
    INVOKE RtlZeroMemory, ADDR DsplServcPacks, 128
    INVOKE RtlZeroMemory, ADDR ServicePack, 32
    MOVZX eax, OpertngSystm.wServicePackMajor
    INVOKE DwtoA, eax, ADDR ServicePack
    INVOKE lstrcpy, ADDR DsplServcPacks, ADDR szInstlSrvcPck    
    INVOKE lstrcat, ADDR DsplServcPacks, ADDR szMajSrvcPk    
    INVOKE lstrcat, ADDR DsplServcPacks, ADDR ServicePack
    INVOKE RtlZeroMemory, ADDR ServicePack, 32
    MOVZX eax, OpertngSystm.wServicePackMinor
    INVOKE DwtoA, eax, ADDR ServicePack
    INVOKE lstrcat, ADDR DsplServcPacks, ADDR szMinrSrvPk
    INVOKE lstrcat, ADDR DsplServcPacks, ADDR ServicePack
    INVOKE lstrcat, ADDR DsplServcPacks, ADDR szEndLine    
    INVOKE lstrlen, ADDR DsplServcPacks
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR DsplServcPacks, dwLenWrt, ADDR dwLenNum, NULL
    JMP InfoGood

NoServcPack:
    invoke lstrlen, ADDR szNoServicePack
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szNoServicePack, dwLenWrt, ADDR dwLenNum, NULL

InfoGood:
    INVOKE lstrlen, ADDR szRowDelmt
    MOV dwLenWrt, eax
    INVOKE WriteFile, hInfFile, ADDR szRowDelmt, dwLenWrt, ADDR dwLenNum, NULL
    INVOKE CloseHandle, hInfFile
    RET

TestForVista ENDP

;***************************************************************************************************
;  The DwtoA procedure is from the masm32 Lib    
;***************************************************************************************************

DwtoA PROC dwValue:DWORD, lpBuffer:DWORD

;***************************************************************************************************
;  Procedure converts DWORD to ascii string.    
;  dwValue is value to be converted
;  lpBuffer is the address of the receiving buffer
;  EXAMPLE:
;  invoke dwtoa,edx,ADDR buffer
;  Uses: eax, ecx, edx.
;  I have modified this slightly, because it reads unsigned
;  values that were originally WORD sized values, zero    
;  extended into a DWORD sized register for convenience.    
;***************************************************************************************************
    push ebx
    push esi
    push edi
    mov eax, dwValue
    mov edi, [lpBuffer]
    test eax,eax
    jnz pos
  zero:
    mov word ptr [edi],30h
    jmp dtaexit
  pos:
    mov ecx, 3435973837
    mov esi, edi
    .WHILE (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      add edi, 1
    .ENDW
    mov byte ptr [edi], 0       ; terminate the string
; We now have all the digits, but in reverse order.
    .WHILE (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .ENDW
  dtaexit:
    pop edi
    pop esi
    pop ebx
    RET  
DwtoA ENDP

;***************************************************************************************************

end start
;***************************************************************************************************

